#include <time.h>
#include "cgic.h"
#include "tracker.h"

#define DEBUG
extern int cgiMain(void)
{
	MYSQL mysql;
	MYSQL_RES *mysqlresult;
	MYSQL_ROW mysqlrow;
    struct ayr ayarlar;
	unsigned int num_rows, i, ii, null_field;
	char query[1024];
	int mysql_durum;
	time_t	curtime;
	struct tm *tmb;
	
	time(&curtime);
	tmb = localtime(&curtime);

    cgiHeaderContentType("text/html");
    fprintf(cgiOut, "<html><head><title>Network Devices and Modules-- Ali BASEL</title></head><body bgcolor=\"#D9D9D9\">");
	fprintf(cgiOut, "<center><h2>Network Devices and Modules</h2>");
	
	openlog("trackercgi", LOG_NOWAIT,  LOG_LOCAL3);
    
	/* Reads sql hostname, username and password from CONFIG_FILE file */
    if( !config_oku(&ayarlar) ) {
        printf("Please look at syslog message file for the error !\n\n");
        exit(0);
    }
    
	
    mysql_init(&mysql);
    if(!mysql_real_connect(&mysql, ayarlar.sqlhost, ayarlar.sqluser, ayarlar.sqlpass, ayarlar.sqldb, SQLPORT, NULL, 0)) {
        syslog(LOG_INFO, "Error:%s, Query:%s\n", mysql_error(&mysql), query);
        exit(0);
	}

	
	sprintf(query, "select Main.MainSerialNo, Main.ModelNo, Main.BuildingName, Main.RoomNumber, Main.Name, Main.IP, Modules.SerialNo, Modules.ModelNo, Modules.Aciklama from Main,Modules where Main.MainSerialNo=Modules.MainSerialNo order by 1");
    #ifdef DEBUG
	    syslog(LOG_INFO, "Find the devices on the network: query=%s\n", query);
    #endif
	mysql_durum=mysql_real_query(&mysql, query, strlen(query));
	if( mysql_durum ) {
		syslog(LOG_INFO, "Error:%s, Query:%s\n", mysql_error(&mysql), query);
		exit(0);
	}
	else { // query succeeded, process any data returned by it
		mysqlresult = mysql_store_result(&mysql);
        	num_rows = mysql_num_rows(mysqlresult);
		#ifdef DEBUG
		syslog(LOG_INFO, " number of rows:%d\n", num_rows);
        	#endif
		if( num_rows ) {
			fprintf(cgiOut, "<table border=1><tr><td>MainSerialNo</td><td>ModelNo</td><td>BuildingName</td><td>RoomNumber</td><td>Name</td><td>IP</td><td>SerialNo</td><td>ModelNo</td><td>Remarque</td></tr>\n");
			for(i=0; i<num_rows; i++) {
				mysqlrow = mysql_fetch_row(mysqlresult);

				/* Check if any of the fields in record is NULL */
				/* When a field is NULL program crashes and dumps a core */
				null_field=0;  
				for(ii=0; ii<8; ii++) 
					if( !mysqlrow[ii] ) {
						syslog(LOG_INFO, "Row:%d, Field:%d is NULL", i, ii);
						null_field=1;
					}
				if( null_field ) continue;

 
				fprintf(cgiOut, "<tr><td>%s</td><td>%s</td><td>%s</td><td>%s</td><td>%s</td><td>%s</td><td>%s</td><td>%s</td><td>%s</td></tr>\n", mysqlrow[0], mysqlrow[1], mysqlrow[2], mysqlrow[3], mysqlrow[4], mysqlrow[5], mysqlrow[6], mysqlrow[7], mysqlrow[8]);
			}
		}
		mysql_free_result(mysqlresult);
	}

	if( !num_rows) {
		syslog(LOG_INFO, "There is no devices in the database !");
		exit(0);
	}
	mysql_close(&mysql);
	
	fprintf(cgiOut, "</table>");
	//fprintf(cgiOut, "<h1>Total Port Number:%d\n</h1>", ToplamPortSayisi);
	fprintf(cgiOut, "[%2d:%2d:%4d][%d:%d:%d]\n", tmb->tm_mday, tmb->tm_mon+1, tmb->tm_year+1900, tmb->tm_hour, tmb->tm_min, tmb->tm_sec);
	fprintf(cgiOut, "</center></html>");	
	return(1);
}
